import { ApolloCache, Cache, Transaction } from 'apollo-cache';
import { DocumentNode } from 'graphql';
export interface OverrideOptions<TCache> {
    read?: <T>(query: Cache.ReadOptions) => T;
    write?: (write: Cache.WriteOptions) => void;
    diff?: <T>(query: Cache.DiffOptions) => Cache.DiffResult<T>;
    watch?: (watch: Cache.WatchOptions) => () => void;
    evict?: (query: Cache.EvictOptions) => Cache.EvictionResult;
    reset?: () => Promise<void>;
    restore?: (serializedState: TCache) => ApolloCache<TCache>;
    extract?: (optimistic: boolean) => TCache;
    removeOptimistic?: (id: string) => void;
    performTransaction?: (transaction: Transaction<any>) => void;
    recordOptimisticTransaction?: (transaction: Transaction<any>, id: string) => void;
    transformDocument?: (document: DocumentNode) => DocumentNode;
}
export declare const override: <TCache>(cache: ApolloCache<TCache>, options?: OverrideOptions<TCache>) => ApolloCache<TCache>;
export declare type RouterFunction = (document: DocumentNode, caches: Array<ApolloCache<any>>) => ApolloCache<any>;
export declare const route: (caches: ApolloCache<any>[], router: RouterFunction) => ApolloCache<any>;
export default class ApolloCacheRouter {
    static override: <TCache>(cache: ApolloCache<TCache>, options?: OverrideOptions<TCache>) => ApolloCache<TCache>;
    static route: (caches: ApolloCache<any>[], router: RouterFunction) => ApolloCache<any>;
}
